from car_util import * # yeahhh don't do this

############
# rear_section
############

def rear_pts(t, bumper, roof, offs):
    base = []

    # top line
    wp1 = wpoints[-2]-0.12
    wp0 = wp1 - 0.15
    wdiff = wp1 - wp0
    for j, wd in enumerate([-wp1, -wp0, wpoints[0], wp0, wp1]):
        if j == 2:
            height = h1+0.11
        else:
            height = h2-0.08
        pos = [wd+offs[0], back_fwd[-2]+offs[1]+0.03, height+offs[2]]
        base.append(pos)
        t.add_joint(pos)

    # centre line, runs from middle line down to bumper
    centre = []
    centre.append(pavg(bumper[1][1][1], bumper[1][1][2]))
    centre.append(pavg(bumper[2][1], bumper[2][2]))
    for pos in centre:
        t.add_joint(pos)

    # points in middle which help with some of the diagonals
    helpers = []
    split = 0.68
    helpers.append(pavg(roof[7], base[0], split))
    helpers.append(pavg(roof[6], base[0], split))
    helpers.append(pavg(roof[5], base[1], split))
    helpers.append(pavg(roof[4], base[1], split))
    helpers.append(pavg(roof[3], base[3], split))
    helpers.append(pavg(roof[2], base[3], split))
    helpers.append(pavg(roof[1], base[4], split))
    helpers.append(pavg(roof[0], base[4], split))
    for pos in helpers:
        t.add_joint(pos, xangle=-20)

    return base, centre, helpers


class RearSection(Group):

    def __init__(self):
        Group.__init__(self)
        self.dflt_pipe_diam = dthin

    def make(self, bumper_pts, rbox_pts, offs):
        roof, boxbase, midbox, midfront = rbox_pts
        base, centre, helpers = rear_pts(self, bumper_pts, roof, offs)

        # connect across top line
        for i in range(len(base)-1):
            self.add_pipe(base[i], base[i+1])
        # connect top line to bumper
        for i in [0, -1]:
            self.add_pipe(base[i], bumper_pts[1][1][i])
            self.add_pipe(base[i], bumper_pts[0][i])
        for i in [0,1]:
            self.add_pipe(base[1], bumper_pts[0][i])
        for i in [-1,-2]:
            self.add_pipe(base[3], bumper_pts[0][i])
        for i in [0,1]:
            self.add_pipe(base[i], bumper_pts[1][1][1])
        for i in [3,4]:
            self.add_pipe(base[i], bumper_pts[1][1][-2])

        # connect along helper (roof-line)
        for i in [0,1,2]:
            self.add_pipe(helpers[i], helpers[i+1])
            self.add_pipe(helpers[7-i], helpers[7-i-1])
        # horizontal under helper-roof-line
        self.add_pipe(helpers[0], helpers[3])
        self.add_pipe(helpers[4], helpers[7])

        # set of diagonals across top part of bumper and backbox
        plist = []
        for i in [0, -1]:
            plist.append([bumper_pts[1][1][i], midbox[i]])

        # right side
        plist.append([base[-1], helpers[6], base[-2]])
        plist.append([midbox[3], helpers[7], roof[0]])
        plist.append([helpers[6],
                      roof[1], helpers[5], roof[2]])
        plist.append([base[2], roof[3], helpers[4], base[-2]])
        plist.append([helpers[4], midbox[2]])


        # left side
        plist.append([base[0], helpers[1], base[1]])
        plist.append([midbox[0], helpers[0], roof[7]])
        plist.append([helpers[1],
                      roof[6], helpers[2], roof[5]])
        plist.append([base[-3], roof[-4], helpers[3], base[1]])
        plist.append([helpers[3], midbox[1]])

        # to top part of bumper
        plist.append([bumper_pts[0][1], base[2], bumper_pts[0][2]])
        # to lower part of bumper (these are really long)
        for i in [1, -2]:
            #plist.append([bumper_pts[1][1][i], boxbase[i], bumper_pts[2][i]])
            plist.append([bumper_pts[1][1][i], boxbase[i], bumper_pts[2][i]])

        # link all the above up...
        for pts in plist:
            for i in range(len(pts)-1):
                self.add_pipe(pts[i], pts[i+1])

        # now connect to mid-points
        plist = []
        plist.append((centre[0], (centre[1],
                                  bumper_pts[2][1], bumper_pts[2][2],
                                  base[2],
                                  bumper_pts[1][1][1], bumper_pts[1][1][2],
                                  )))
        plist.append((centre[1], (bumper_pts[2][1], bumper_pts[2][2],
                                  boxbase[1], boxbase[2], # really long
                    )))
        for pt, pts in plist:
            for i in range(len(pts)):
                thickness = dthin
                if pts[i] == bumper_pts[2][1]: thickness = dthick
                if pts[i] == bumper_pts[2][2]: thickness = dthick
                if pts[i] == base[2]: thickness = dthick
                if pts[i] == centre[1]: thickness = dthick
                self.add_pipe(pt, pts[i], thickness)

        # complex ones
        self.add_pipe(base[-2], helpers[5], dthin, jfurotz1, AUTO)
        self.add_pipe(base[1], helpers[2], dthin, jfurotz2, AUTO)
        self.add_pipe(helpers[7], base[-1], dthin, jback, jrfrotz2)
        self.add_pipe(helpers[0], base[0], dthin, jback, jlfrotz2)
        self.add_pipe(roof[1], helpers[7], dthin, jrbd3)
        self.add_pipe(roof[2], helpers[4], dthin, jlbdrotz, jfu)
        self.add_pipe(roof[5], helpers[3], dthin, jrbdrotz, jfu)
        self.add_pipe(roof[-2], helpers[0], dthin, jlbd3)
        for j, i, offs1 in [(0, 1, jrbd3), (-1, -2, jlbd3)]:
            self.add_pipe(midbox[j], bumper_pts[1][1][i], dthin, offs1)
        for i, offs1 in [(0, jrbrot), (-1, jlbrot)]:
            self.add_pipe(midbox[i], base[i], dthin, offs1)
        for j, i in [(0, 1), (-1, -2)]:
            self.add_pipe(base[i], midbox[i], dthin, jfd)
        for j, i, offs1 in [(0, 1, jlbd3), (-1, -2, jrbd3)]:
            self.add_pipe(midbox[i], bumper_pts[1][1][i], dthin, offs1)
        # to mid-point
        self.add_pipe(base[2], midbox[2], dthin, jdr, jlbu3)
        self.add_pipe(base[2], midbox[1], dthin, jdl, jrbu3)
        self.add_pipe(centre[0], midbox[2], dthin, AUTO, jlbd3)
        self.add_pipe(centre[0], midbox[1], dthin, AUTO, jrbd3)
        self.add_pipe(centre[0], base[1], dthin, AUTO, jdrrot2)
        self.add_pipe(centre[0], base[3], dthin, AUTO, jdlrot2)

        return base, self
